@echo off
set ERROR_CODE=0

echo Update Start

rem ------ Check Service Status ------
echo Checking Service Status...
net start |find "ESMNVMeMonitor" > NUL 2>&1
if %errorlevel% EQU 1 goto ERROR1

rem ------ Service Stop ------
echo Stopping service...
net stop "ESMNVMeMonitor" > NUL 2>&1
if %errorlevel% NEQ 0 goto ERROR2

rem ------ Make backup files ------
echo Making backup files...
copy /y %ESMDir%\tool\Intel.SSDFeatures.1.2.0.dll %ESMDir%\tool\Intel.SSDFeatures.1.2.0.dll.bak > NUL 2>&1
if %errorlevel% NEQ 0 goto ERROR3

copy /y %ESMDir%\tool\isdct.exe %ESMDir%\tool\isdct.exe.bak > NUL 2>&1
if %errorlevel% NEQ 0 goto ERROR4

copy /y %ESMDir%\tool\LSI.AdapterAPI.4.02.dll %ESMDir%\tool\LSI.AdapterAPI.4.02.dll.bak > NUL 2>&1
if %errorlevel% NEQ 0 goto ERROR5

rem ------ Update files ------
echo Updating files...
copy /y %~dp0module\Intel.SSDFeatures.1.2.0.dll %ESMDir%\tool\Intel.SSDFeatures.1.2.0.dll > NUL 2>&1
if %errorlevel% NEQ 0 goto ERROR6

copy /y %~dp0module\isdct.exe %ESMDir%\tool\isdct.exe > NUL 2>&1
if %errorlevel% NEQ 0 goto ERROR7

copy /y %~dp0module\LSI.AdapterAPI.4.02.dll %ESMDir%\tool\LSI.AdapterAPI.4.02.dll > NUL 2>&1
if %errorlevel% NEQ 0 goto ERROR8

rem ------ Delete files ------
echo Deleting files...
if exist %ESMDir%\dat\esmnvme.dat (
    del %ESMDir%\dat\esmnvme.dat > NUL 2>&1
    if exist %ESMDir%\dat\esmnvme.dat goto ERROR9
)

del %ESMDir%\tool\Intel.SSDFeatures.1.2.0.dll.bak > NUL 2>&1

del %ESMDir%\tool\isdct.exe.bak > NUL 2>&1

del %ESMDir%\tool\LSI.AdapterAPI.4.02.dll.bak > NUL 2>&1

rem ------ Service Start ------
echo Starting service...
net start "ESMNVMeMonitor" > NUL 2>&1
if %errorlevel% NEQ 0 goto ERROR10

goto ERRORECHO

:ERROR1
set ERROR_CODE=1
goto ERRORECHO

:ERROR2
set ERROR_CODE=2
goto ERRORECHO

:ERROR3
set ERROR_CODE=3
goto ERRORECHO

:ERROR4
set ERROR_CODE=4
goto ERRORECHO

:ERROR5
set ERROR_CODE=5
goto ERRORECHO

:ERROR6
set ERROR_CODE=6
goto ERRORECHO

:ERROR7
set ERROR_CODE=7
goto ERRORECHO

:ERROR8
set ERROR_CODE=8
goto ERRORECHO

:ERROR9
set ERROR_CODE=9
goto ERRORECHO

:ERROR10
set ERROR_CODE=10
goto ERRORECHO

:ERRORECHO
IF %ERROR_CODE%==0 (
    echo Update End
) ELSE (
    echo error code:%ERROR_CODE%
)
if not "%1"=="/s" pause
exit /b %ERROR_CODE%